/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package action;

import constants.WebConstants;
import model.Korisnik;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.persistence.EntityManager;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.transaction.UserTransaction;
import repozitorijum.Repozitorijum;

/**
 *
 * @author student
 */
public class LoginAction extends AbstractAction{

    @Override
    public String execute(HttpServletRequest request) {
        try {
            String username = request.getParameter("inputKorisnickoIme");
            String pass = request.getParameter("inputKorisnickaSifra");
            //Korisnik k = Repozitorijum.getInstance().login(username, pass);
            Korisnik k = login(username, pass);
            HttpSession sesija = request.getSession(true);
            sesija.setAttribute(WebConstants.USER_LOGIN, k);
            return WebConstants.PAGE_INDEX;
        } catch (Exception ex) {
            return WebConstants.PAGE_LOGIN;
        }
        
    }

    public Korisnik login(String korisnickoIme, String korisnickaSifra) throws Exception {

        try {
            Context ctx = new InitialContext();
            //UserTransaction utx = (UserTransaction) ctx.lookup("java:comp/env/UserTransaction");
            //utx.begin();
            EntityManager em = (EntityManager) ctx.lookup("java:comp/env/persistence/LogicalName");
            Korisnik k = em.find(Korisnik.class, korisnickoIme);
            if(k == null){
                throw  new Exception("Korisnik ne postoji!");
            }
            if(k.getKorisnickasifra().equals(korisnickaSifra)){
                return k;
            }
            else throw new Exception("Korisnik ne postoji!");
            //em.persist(object);
            //utx.commit();
        } catch (Exception e) {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", e);
            throw e;
        }
        
    }
    
}
