/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package action;

import constants.WebConstants;
import model.Korisnik;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.persistence.EntityManager;
import javax.servlet.http.HttpServletRequest;
import javax.transaction.UserTransaction;
import repozitorijum.Repozitorijum;

/**
 *
 * @author student
 */
public class GetAllUserAction extends AbstractAction{

    @Override
    public String execute(HttpServletRequest request) {
        //List<Korisnik> korisnici = Repozitorijum.getInstance().vratiSveKorisnike();
        List<Korisnik> korisnici = getAllUsers();
        request.setAttribute(WebConstants.ALL_USERS, korisnici);
        return WebConstants.PAGE_ALL_USERS;
    }

    public List<Korisnik> getAllUsers() {
        try {
            Context ctx = new InitialContext();
            EntityManager em = (EntityManager) ctx.lookup("java:comp/env/persistence/LogicalName");
            List<Korisnik> korisnici = em.createNamedQuery("Korisnik.findAll").getResultList();
            return korisnici;
        } catch (Exception e) {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", e);
            throw new RuntimeException(e);
        }
    }
    
    
    
}
